/*
  ******************************************************************************
  * @file    apt32f103_bt.c
  * @author  
  * @version V1.00
  * @date    2023/02/01
  ******************************************************************************
  *THIS SOFTWARE WHICH IS FOR ILLUSTRATIVE PURPOSES ONLY WHICH PROVIDES 
  *CUSTOMER WITH CODING INFORMATION REGARDING THEIR PRODUCTS.
  *APT CHIP SHALL NOT BE HELD RESPONSIBILITY ADN LIABILITY FOR ANY DIRECT, 
  *INDIRECT DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF 
  *SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION 
  *CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.AND APT CHIP RESERVES 
  *THE RIGHT TO MAKE CHANGES IN THE SOFTWARE WITHOUT NOTIFICATION
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "apt32f103_bt.h"

/* defines -------------------------------------------------------------------*/
/* externs--------------------------------------------------------------------*/


/*************************************************************/
//Deinitializes the registers to their default reset
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/    
void BT_DeInit(CSP_BT_T *BTx)
{
	BTx->CR=0X01;
	BTx->RSSR=BT_RESET_VALUE;
	BTx->PSCR=BT_RESET_VALUE;
	BTx->PRDR=BT_RESET_VALUE;
	BTx->CMP=BT_RESET_VALUE;
	BTx->CNT=BT_RESET_VALUE;
	BTx->EVTRG=BT_RESET_VALUE;
	BTx->EVSWF=BT_RESET_VALUE;
	BTx->RISR=BT_RESET_VALUE;
	BTx->IMCR=BT_RESET_VALUE;
	BTx->MISR=BT_RESET_VALUE;
	BTx->ICR=BT_RESET_VALUE;
}
/*************************************************************/
//BT IO Init
//EntryParameter:
//ReturnValue:NONE
/*************************************************************/
void BT_IO_Init(BT_Pin_TypeDef BT_IONAME)
{
	if(BT_IONAME==BT0_PB0_2)
	{
		GPIOB0->CONLR=(GPIOB0->CONLR & 0XFFFFF0FF)|0x00000500;		//BT0_PB0_2    = 0, 	//AF2  5
	}
	if(BT_IONAME==BT0_PA0_11)
	{
		GPIOA0->CONHR=(GPIOA0->CONHR & 0XFFFF0FFF)|0x00008000;		//BT0_PA0_11   = 1, 	//AF5  8
	}
	if(BT_IONAME==BT0_PA0_5)
	{
		GPIOA0->CONLR=(GPIOA0->CONLR & 0XFF0FFFFF)|0x00500000;		//BT0_PA0_5	   = 2，	//AF2  5  SWCLK
	}
	if(BT_IONAME==BT0_PA0_13)
	{
		GPIOA0->CONHR=(GPIOA0->CONHR & 0XFF0FFFFF)|0x00800000;		//BT0_PA0_13   = 3，    //AF5  8
	}
	if(BT_IONAME==BT0_PB0_5)
	{
		GPIOB0->CONLR=(GPIOB0->CONLR & 0XFF0FFFFF)|0x00700000;		// BT0_PB0_5    = 4，   //AF4 7
	}
	if(BT_IONAME==BT0_PA0_15)
	{
		GPIOA0->CONHR=(GPIOA0->CONHR & 0X0FFFFFFF)|0x50000000;		//BT0_PA0_15   = 5，    //AF2  5  
	}
	if(BT_IONAME==BT0_PB0_9)
	{
		GPIOB0->CONHR=(GPIOB0->CONHR & 0XFFFFFF0F)|0x00000040;		//BT0_PB0_9    = 6，    //AF1  4 
	}
	
	if(BT_IONAME==BT1_PA0_6)
	{
		GPIOA0->CONLR=(GPIOA0->CONLR & 0XF0FFFFFF)|0x04000000;		//BT1_PA0_6    = 7，    //AF1  4 
	}
	if(BT_IONAME==BT1_PA0_8)
	{
		GPIOA0->CONHR=(GPIOA0->CONHR & 0XFFFFFFF0)|0x00000006;		//BT1_PA0_8    = 8，    //AF3  6 
	}
	if(BT_IONAME==BT1_PA0_12)
	{
		GPIOA0->CONHR=(GPIOA0->CONHR & 0XFFF0FFFF)|0x00060000;		//BT1_PA0_12   = 9，    //AF3  6  SWDIO
	}
	if(BT_IONAME==BT1_PB0_0)
	{
		GPIOB0->CONLR=(GPIOB0->CONLR & 0XFFFFFFF0)|0x00000008;		//BT1_PB0_0    = 10，   //AF5  8  
	}
	if(BT_IONAME==BT1_PB0_4)
	{
		GPIOB0->CONLR=(GPIOB0->CONLR & 0XFFF0FFFF)|0x00070000;		//BT1_PB0_4    = 11，   //AF4  7  
	}
	if(BT_IONAME==BT1_PA0_14)
	{
		GPIOA0->CONHR=(GPIOA0->CONHR & 0XF0FFFFFF)|0x05000000;		//BT1_PA0_14   = 12，   //AF2  5      
	}
	if(BT_IONAME==BT1_PA0_1)
	{
		GPIOA0->CONLR=(GPIOA0->CONLR & 0XFFFFFF0F)|0x00000060;		//BT1_PA0_1    = 13     //AF3  6
	}
}
/*************************************************************/
// BT start
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/ 
void BT_Start(CSP_BT_T *BTx)
{
	BTx->RSSR |=0X01;
}
/*************************************************************/
// BT stop
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/ 
void BT_Stop(CSP_BT_T *BTx)
{
	BTx->RSSR &=0X0;
}
/*************************************************************/
// BT stop High
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/ 
void BT_Stop_High(CSP_BT_T *BTx)
{
	BTx->CR |=(0x01<<6);
	BTx->RSSR &=0X0;
}
/*************************************************************/
// BT stop Low
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/ 
void BT_Stop_Low(CSP_BT_T *BTx)
{
	BTx->CR =BTx->CR & ~(0x01<<6);
	BTx->RSSR &=0X0;
}
/*************************************************************/
// BT soft reset
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/ 
void BT_Soft_Reset(CSP_BT_T *BTx)
{
	BTx->RSSR |= (0X5<<12);
}
/*************************************************************/
//BT Configure
//EntryParameter:
//ReturnValue:NONE
/*************************************************************/
void BT_Configure(CSP_BT_T *BTx,BT_CLK_TypeDef BTCLK,U16_T PSCR_DATA,BT_SHDWSTP_TypeDef BTSHDWSTP,BT_OPM_TypeDef BTOPM,BT_EXTCKM_TypeDef BTEXTCKM)
{
	BTx->CR |=BTCLK| BTSHDWSTP| BTOPM| BTEXTCKM;
	BTx->PSCR = PSCR_DATA;
}
/*************************************************************/
//BT ControlSet
//EntryParameter:
//ReturnValue:NONE
/*************************************************************/
void BT_ControlSet_Configure(CSP_BT_T *BTx,BT_STARTST_TypeDef BTSTART,BT_IDLEST_TypeDef BTIDLE,BT_CNTRLD_TypeDef BTCNTRLD)
{
	BTx->CR |=BTSTART| BTIDLE| BTCNTRLD;
}
/*************************************************************/
//BT SYN ControlSet
//EntryParameter:
//ReturnValue:NONE
/*************************************************************/
void BT_SYN_Control_Config(CSP_BT_T *BTx, BT_SYNCEN_Channel_TypeDef BT_SYNCEN_Channel_x, BT_SYNCEN_TypeDef BTSYNC, BT_OSTMDX_TypeDef BTOSTMD
			,BT_SYNCMD_TypeDef BTSYNCMD, BT_AREARM_TypeDef BTAREARM)
{
	if(BT_SYNCEN_Channel_x==BT_SYN_Channel0)
	{
		BTx->CR &=0XEEFFFEFF;
		BTx->CR|=BTSYNC|BTOSTMD|BTSYNCMD|BTAREARM;
	}
	else if(BT_SYNCEN_Channel_x==BT_SYN_Channel1)
	{
		BTx->CR &=0XDDFFFDFF;
		BTx->CR|=(BTSYNC<<1)|(BTOSTMD<<1)|BTSYNCMD|BTAREARM;
	}
	else if(BT_SYNCEN_Channel_x==BT_SYN_Channel2)
	{
		BTx->CR &=0XBBFFFBFF;
		BTx->CR|=(BTSYNC<<2)|(BTOSTMD<<2)|BTSYNCMD|BTAREARM;
	}
}

/*************************************************************/
//BT Period / Compare set
//EntryParameter:
//ReturnValue:NONE
/*************************************************************/
void BT_Period_CMP_Write(CSP_BT_T *BTx,U16_T BTPRDR_DATA,U16_T BTCMP_DATA)
{
	//BTx->CR|=0X01<<2;
	BTx->PRDR =BTPRDR_DATA;
	BTx->CMP =BTCMP_DATA;
}
/*************************************************************/
//BT COUNTER set
//EntryParameter:
//ReturnValue:NONE
/*************************************************************/
void BT_CNT_Write(CSP_BT_T *BTx,U16_T BTCNT_DATA)
{
	BTx->CNT =BTCNT_DATA;
}
/*************************************************************/
//BT read counters
//EntryParameter:
//ReturnValue:NONE
/*************************************************************/
U16_T BT_PRDR_Read(CSP_BT_T *BTx)
{
    return BTx->PRDR;
}
U16_T BT_CMP_Read(CSP_BT_T *BTx)
{
    return BTx->CMP;
}
U16_T BT_CNT_Read(CSP_BT_T *BTx)
{
    return BTx->CNT;
}
/*************************************************************/
//BT Trigger Init
//EntryParameter:
//ReturnValue:NONE
/*************************************************************/
void BT_Trigger_Configure(CSP_BT_T *BTx,BT_TRGSRC_TypeDef BTTRG,BT_TRGOE_TypeDef BTTRGOE)
{
	BTx->EVTRG|=BTTRG| BTTRGOE;
}
/*************************************************************/
//BT SOFT Trigger
//EntryParameter:
//ReturnValue:NONE
/*************************************************************/
void BT_Soft_Tigger(CSP_BT_T *BTx)
{
	BTx->EVSWF=0x01;
}
/*************************************************************/
//BT inturrpt Configure
//EntryParameter:BT_IMSCR_X,NewState
//NewState:ENABLE,DISABLE
//ReturnValue:NONE
/*************************************************************/ 
void BT_ConfigInterrupt_CMD(CSP_BT_T *BTx,FunctionalStatus NewState,BT_IMSCR_TypeDef BT_IMSCR_X)
{
	if (NewState != DISABLE)
	{
		BTx->IMCR  |= BT_IMSCR_X;						
	}
	else
	{
		BTx->IMCR  &= ~BT_IMSCR_X;					
	}
}
/*************************************************************/
//BT0 Interrupt enable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void BT0_INT_ENABLE(void)
{
	csi_vic_enable_irq(BT0_IRQ_NUM); 
}
/*************************************************************/
//BT0 Interrupt disable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void BT0_INT_DISABLE(void)
{
	csi_vic_disable_irq(BT0_IRQ_NUM); 
}
/*************************************************************/
//BT1 Interrupt enable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void BT1_INT_ENABLE(void)
{
	csi_vic_enable_irq(BT1_IRQ_NUM); 
}
/*************************************************************/
//BT1 Interrupt disable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void BT1_INT_DISABLE(void)
{
	csi_vic_disable_irq(BT1_IRQ_NUM);
}
/*************************************************************/
//BT2 Interrupt enable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void BT2_INT_ENABLE(void)
{
	csi_vic_enable_irq(BT2_IRQ_NUM); 
}
/*************************************************************/
//BT2 Interrupt disable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void BT2_INT_DISABLE(void)
{
	csi_vic_disable_irq(BT2_IRQ_NUM);
}
/*************************************************************/
//BT3 Interrupt enable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void BT3_INT_ENABLE(void)
{
	csi_vic_enable_irq(BT3_IRQ_NUM); 
}
/*************************************************************/
//BT3 Interrupt disable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void BT3_INT_DISABLE(void)
{
	csi_vic_disable_irq(BT3_IRQ_NUM);
}
/*************************************************************/
//Initialize BT3, timing 10ms; 
//BT3 timing is used as Tkey reference clock
//NewState:ENABLE,DISABLE
//ReturnValue:NONE
/*************************************************************/
void tkey_basetime_init(U16_T basecnt_ms)
{
	U16_T prdr_temp;
	switch ((SYSCON->OPT1&0x00000030)>>4) {
		case 0:prdr_temp=6000;break;
		case 1:prdr_temp=3000;break;
		case 2:prdr_temp=1500;break;
		case 3:prdr_temp=750;break;
		default:prdr_temp=6000;break;
	}
	prdr_temp=prdr_temp*basecnt_ms;
	BT_DeInit(BT3);
	BT_Configure(BT3,BTCLK_EN,7,BT_IMMEDIATE,BT_CONTINUOUS,BT_PCLKDIV);
	BT_Period_CMP_Write(BT3,prdr_temp,0);
	BT_ConfigInterrupt_CMD(BT3,ENABLE,BT_PEND);
	BT3_INT_ENABLE();
	BT_Start(BT3);
}
/******************* (C) COPYRIGHT 2023 APT Chip *****END OF FILE****/