/*
  ******************************************************************************
  * @file    apt32f103_syscon.c
  * @author 
  * @version V1.00
  * @date    2023/02/01
  ******************************************************************************
  *THIS SOFTWARE WHICH IS FOR ILLUSTRATIVE PURPOSES ONLY WHICH PROVIDES 
  *CUSTOMER WITH CODING INFORMATION REGARDING THEIR PRODUCTS.
  *APT CHIP SHALL NOT BE HELD RESPONSIBILITY ADN LIABILITY FOR ANY DIRECT, 
  *INDIRECT DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF 
  *SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION 
  *CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.AND APT CHIP RESERVES 
  *THE RIGHT TO MAKE CHANGES IN THE SOFTWARE WITHOUT NOTIFICATION
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "apt32f103_syscon.h"
#include "apt32f103_uart.h"
/* define --------------------------------------------------------------------*/
#ifndef __ALWAYS_STATIC_INLINE
#define __ALWAYS_STATIC_INLINE  __attribute__((always_inline)) static inline
#endif
/* externs--------------------------------------------------------------------*/
extern void asm_delay_ms(void);
/*************************************************************/
//Deinitializes the syscon registers to their default reset
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/    
void SYSCON_RST_VALUE(void)									//reset value
{
	//SYSCON->IDCCR=SYSCON_IDCCR_RST;
	//SYSCON->GCER=SYSCON_GCER_RST;
	//SYSCON->GCDR=SYSCON_GCDR_RST;
	//SYSCON->GCSR=SYSCON_GCSR_RST;
	//SYSCON->CKST=SYSCON_CKST_RST;
	SYSCON->RAMCHK=SYSCON_RAMCHK_RST;
	SYSCON->EFLCHK=SYSCON_EFLCHK_RST;
	SYSCON->SCLKCR=SYSCON_SCLKCR_RST;
	//SYSCON->PCLKCR=SYSCON_PCLKCR_RST;
	//SYSCON->PCER0=SYSCON_PCER0_RST;
	//SYSCON->PCDR0=SYSCON_PCDR0_RST;
	//SYSCON->PCSR0=SYSCON_PCSR0_RST;
	//SYSCON->PCER1=SYSCON_PCER1_RST;
	//SYSCON->PCDR1=SYSCON_PCDR1_RST;
	//SYSCON->PCSR1=SYSCON_PCSR1_RST;
	SYSCON->OSTR=SYSCON_OSTR_RST;
	SYSCON->LVDCR=SYSCON_LVDCR_RST;
	//SYSCON->CLCR=SYSCON_CLCR_RST;
	//SYSCON->PWRCR=SYSCON_PWRCR_RST;
	//SYSCON->PWRKEY=SYSCON_PWRKEY_RST;
	//SYSCON->IMER=SYSCON_IMER_RST;
	//SYSCON->IMDR=SYSCON_IMDR_RST;
	//SYSCON->IMCR=SYSCON_IMCR_RST;
	//SYSCON->IAR=SYSCON_IAR_RST;
	//SYSCON->ICR=SYSCON_ICR_RST;
	//SYSCON->RISR=SYSCON_RISR_RST;
	//SYSCON->MISR=SYSCON_MISR_RST;
	SYSCON->EXIRT=SYSCON_EXIRT_RST;
	SYSCON->EXIFT=SYSCON_EXIFT_RST;
	//SYSCON->EXIER=SYSCON_EXIER_RST;
	//SYSCON->EXIDR=SYSCON_EXIDR_RST;
	//SYSCON->EXIMR=SYSCON_EXIMR_RST;
	//SYSCON->EXIAR=SYSCON_EXIAR_RST;
	//SYSCON->EXICR=SYSCON_EXICR_RST;
	//SYSCON->EXIRS=SYSCON_EXIRS_RST;
	SYSCON->IWDCR=SYSCON_IWDCR_RST;
	SYSCON->IWDCNT=SYSCON_IWDCNT_RST;
	//SYSCON->PWROPT=SYSCON_PWROPT_RST;
	SYSCON->EVTRG=SYSCON_EVTRG_RST;
	SYSCON->EVPS=SYSCON_EVPS_RST;
	SYSCON->EVSWF=SYSCON_EVSWF_RST;
	SYSCON->UREG0=SYSCON_UREG0_RST;
	SYSCON->UREG1=SYSCON_UREG1_RST;
	SYSCON->UREG2=SYSCON_UREG2_RST;
	//SYSCON->UREG3=SYSCON_UREG3_RST;
}
/*************************************************************/
//EMOSC OSTR Config
//EM_CNT:0~0X3FF
//EM_GM:0~0X1F
//EM_FLEN;EM_FLEN_DIS,EM_FLEN_EN
//EM_FLSEL:EM_FLSEL_5ns,EM_FLSEL_10ns,EM_FLSEL_15ns,EM_FLSEL_20ns
/*************************************************************/  
void EMOSC_OSTR_Config(U16_T EM_CNT, U8_T EM_GM,EM_LFSEL_TypeDef EM_LFSEL_X, EM_Filter_CMD_TypeDef EM_FLEN_X, EM_Filter_TypeDef EM_FLSEL_X)
{
	SYSCON->OSTR= (SYSCON->OSTR&0xf1ff0000)|(EM_CNT|(EM_GM<<11)|EM_LFSEL_X|EM_FLEN_X|EM_FLSEL_X);
}
/*************************************************************/
//SYSCON General Control
//EntryParameter:NewState:,ENDIS_X
//NewState:ENABLE,DISABLE
//ENDIS_X:ENDIS_ISOSC,ENDIS_IMOSC,ENDIS_EMOSC,ENDIS_HFOSC
//ReturnValue:NONE
/*************************************************************/  
void SYSCON_General_CMD(FunctionalStatus NewState, SYSCON_General_CMD_TypeDef ENDIS_X )
{
	if (NewState != DISABLE)
	{
		if(ENDIS_X==ENDIS_EMOSC) 
		GPIOA0->CONLR=(GPIOA0->CONLR & 0XFFF00FFF)|0x00044000;					//enable EMOSC PIN  PA0.3(OSC_XI) PA0.4(OSC_XO)
		SYSCON->GCER|=ENDIS_X;													//enable SYSCON General Control
		while(!(SYSCON->GCSR&ENDIS_X));											//check  Enable?	
		
		if(ENDIS_X==ENDIS_IMOSC)
		{
			while (!(SYSCON->CKST & ENDIS_IMOSC)); 	
		}
		if(ENDIS_X==ENDIS_EMOSC)
		{
			while (!(SYSCON->CKST & ENDIS_EMOSC)); 
		}
		if(ENDIS_X==ENDIS_ISOSC)
		{
			while (!(SYSCON->CKST & ENDIS_ISOSC)); 
		}
		if(ENDIS_X==ENDIS_HFOSC)
		{
			while (!(SYSCON->CKST & ENDIS_HFOSC)); 
		}
	}
	else
	{
		SYSCON->GCDR|=ENDIS_X;													//disable SYSCON General Control
		while(SYSCON->GCSR&ENDIS_X);											//check Disable?
		SYSCON->ICR|=ENDIS_X;													//Clear ENDIS_X stable bit
	}
}

/*************************************************************/
//Seleted system clk and seleted clk div
//EntryParameter:SYSCLK_X,HCLK_DIV_X,PCLK_DIV_X
//SYSCLK_X:SYSCLK_IMOSC,SYSCLK_EMOSC,SYSCLK_ISOSC,SYSCLK_HFOSC,SYSCLK_ESOSC
//HCLK_DIV_X:HCLK_DIV_1/2/3/4/5/6/7/8/12/16/24/32/64/128/256
//PCLK_DIV_X:PCLK_DIV_1,PCLK_DIV_2,PCLK_DIV_4,PCLK_DIV_8,PCLK_DIV_16
//SystemClk_data_x:EMOSC_24M,EMOSC_16M,EMOSC_12M,EMOSC_8M,EMOSC_4M,EMOSC_36K,
//ISOSC,IMOSC,HFOSC_48M,HFOSC_24M,HFOSC_12M,HFOSC_6M
//ReturnValue:NONE
/*************************************************************/ 
void SystemCLK_HCLKDIV_PCLKDIV_Config(SystemCLK_TypeDef SYSCLK_X , SystemCLK_Div_TypeDef HCLK_DIV_X , PCLK_Div_TypeDef PCLK_DIV_X , SystemClk_data_TypeDef SystemClk_data_x )
{
	if(SystemClk_data_x==HFOSC_48M)
	{
		IFC->CEDR=0X01;						//CLKEN
		IFC->MR=0X04|(0X00<<16);			//High speed mode
	}
	if((SystemClk_data_x==EMOSC_24M)||(SystemClk_data_x==HFOSC_24M))
	{
		IFC->CEDR=0X01;						//CLKEN
		IFC->MR=0X01|(0X01<<16);			//Medium speed mode
	}
	if((SystemClk_data_x==EMOSC_12M)||(SystemClk_data_x==HFOSC_12M)||(SystemClk_data_x==EMOSC_16M))
	{
		IFC->CEDR=0X01;						//CLKEN
		IFC->MR=0X01|(0X00<<16);			//Low speed mode
	}
	if((SystemClk_data_x==EMOSC_8M)||(SystemClk_data_x==EMOSC_4M)||(SystemClk_data_x==EMOSC_36K)||(SystemClk_data_x==ESOSC_32K)
		||(SystemClk_data_x==IMOSC)||(SystemClk_data_x==ISOSC)||(SystemClk_data_x==HFOSC_6M))
	{
		IFC->CEDR=0X01;						//CLKEN
		IFC->MR=0X00|(0X00<<16);			//Low speed mode
	}
	SYSCON->SCLKCR=SYSCLK_KEY | HCLK_DIV_X| SYSCLK_X;
	while (!(SYSCON->CKST & (1<<8))); 											// waiting for sysclk stable
	SYSCON->PCLKCR=PCLK_KEY|PCLK_DIV_X;											//PCLK DIV 1 2 4 6 8 16		
	while(SYSCON->PCLKCR!=PCLK_DIV_X);											//Wait PCLK DIV
	
	SYSCON_WDT_CMD(DISABLE);
	SYSCON_General_CMD(ENABLE,ENDIS_LP_ISOEN);
}
/*************************************************************/
//clear system clk register
//ReturnValue:NONE
/*************************************************************/ 
void SystemCLK_Clear(void)
{
	SYSCON->SCLKCR=0xd22d0000;
	while(SYSCON->SCLKCR!=0);
}
/*************************************************************/
//SYSCON IMOSC SELECTE
//EntryParameter:IMOSC_SELECTE_X
//IMOSC_SELECTE_X:IMOSC_SELECTE_5556K,IMOSC_SELECTE_4194K;IMOSC_SELECTE_2097K;IMOSC_SELECTE_131K
//ReturnValue:NONE
/*************************************************************/  
void SYSCON_IMOSC_SELECTE(IMOSC_SELECTE_TypeDef IMOSC_SELECTE_X)
{		
	//SYSCON_General_CMD(DISABLE,ENDIS_IMOSC);					//disalbe IMOSC
	SYSCON->OPT1 = (SYSCON->OPT1 & 0XFFFFFFFC)|IMOSC_SELECTE_X;	//IMOSC CLK selected
	//SYSCON_General_CMD(ENABLE,ENDIS_IMOSC);						//enable IMOSC
}
/*************************************************************/
//SYSCON HFOSC SELECTE
//EntryParameter:HFOSC_SELECTE_X
//HFOSC_SELECTE_X:HFOSC_SELECTE_48M,HFOSC_SELECTE_24M;HFOSC_SELECTE_12M;HFOSC_SELECTE_6M
//ReturnValue:NONE
/*************************************************************/  
void SYSCON_HFOSC_SELECTE(HFOSC_SELECTE_TypeDef HFOSC_SELECTE_X)
{		
	SYSCON_General_CMD(DISABLE,ENDIS_HFOSC);					//disable HFOSC
	SYSCON->OPT1 = (SYSCON->OPT1 & 0XFFFFFFCF)|HFOSC_SELECTE_X;
	SYSCON_General_CMD(ENABLE,ENDIS_HFOSC);						//enable HFOSC
}
/*************************************************************/
//WDT enable and disable 
//EntryParameter:,NewState
//NewState:ENABLE,DISABLE
//ReturnValue:NONE
/*************************************************************/
void SYSCON_WDT_CMD(FunctionalStatus NewState)
{
	if(NewState != DISABLE)
	{
		SYSCON->IWDEDR=IWDTEDR_KEY|Enable_IWDT;
		while(!(SYSCON->IWDCR&Check_IWDT_BUSY));
	}
	else
	{
		SYSCON->IWDEDR=IWDTEDR_KEY|Disable_IWDT;
		while(SYSCON->IWDCR&Check_IWDT_BUSY);
	}
}
/*************************************************************/
//reload WDT CN
//EntryParameter:NONE
//ReturnValue: NONE
/*************************************************************/
void SYSCON_IWDCNT_Reload(void)
{
	SYSCON->IWDCNT=CLR_IWDT;
}
/*************************************************************/
//IWDCNT Config
//EntryParameter:NewStateE_IWDT_SHORT,IWDT_TIME_X,IWDT_INTW_DIV_X
//NewStateE_IWDT_SHORT:ENABLE_IWDT_SHORT,DISABLE_IWDT_SHORT
//IWDT_TIME_X:IWDT_TIME_128MS,IWDT_TIME_256MS,IWDT_TIME_500MS,IWDT_TIME_1S,IWDT_TIME_2S,IWDT_TIME_3S,IWDT_TIME_4S,IWDT_TIME_8S
//IWDT_INTW_DIV_X:IWDT_INTW_DIV_1/2/3/4/4/5/6
//ReturnValue: NONE
/*************************************************************/
void SYSCON_IWDCNT_Config(IWDT_TIME_TypeDef IWDT_TIME_X , IWDT_TIMEDIV_TypeDef IWDT_INTW_DIV_X )
{
	SYSCON->IWDCR=IWDT_KEY|IWDT_TIME_X|IWDT_INTW_DIV_X;
}
/*************************************************************/
//LVD Config  and set LVD INT
//EntryParameter:X_LVDEN,INTDET_LVL_X,RSTDET_LVL_X,X_LVD_INT
//X_LVDEN:ENABLE_LVDEN,DISABLE_LVDEN
//LVDRST_CMD:LVDRST_EN,LVDRST_DIS
//INTDET_LVL_X:INTDET_LVL_1_8V,INTDET_LVL_2_1V,INTDET_LVL_2_5V,INTDET_LVL_2_9V,INTDET_LVL_3_3V,INTDET_LVL_3_7V,INTDET_LVL_4_1V,INTDET_LVL_4_5V
//RSTDET_LVL_X:RSTDET_LVL_1_6V,RSTDET_LVL_2_0V,RSTDET_LVL_2_4V,RSTDET_LVL_2_8V,RSTDET_LVL_3_2V,RSTDET_LVL_3_6V,RSTDET_LVL_4_0V,RSTDET_LVL_4_4V
//INTDET_POL_X:INTDET_POL_fall,INTDET_POL_X_rise,INTDET_POL_X_riseORfall
//ReturnValue: NONE
/*************************************************************/
void SYSCON_LVD_Config(X_LVDEN_TypeDef X_LVDEN , INTDET_LVL_X_TypeDef INTDET_LVL_X , RSTDET_LVL_X_TypeDef RSTDET_LVL_X , INTDET_POL_X_TypeDef INTDET_POL_X)
{
	//SYSCON->LVDCR=LVD_KEY;
	SYSCON->LVDCR=LVD_KEY|X_LVDEN|INTDET_LVL_X|RSTDET_LVL_X|INTDET_POL_X;
}
/*************************************************************/
//LVD INT ENABLE.
//EntryParameter:NONE
//ReturnValue: NONE
/*************************************************************/
void LVD_Int_Enable(void)
{
	SYSCON->ICR = LVD_INT_ST;				//clear LVD INT status
	SYSCON->IMER  |= LVD_INT_ST;
}
/*************************************************************/
//LVD INT DISABLE.
//EntryParameter:NONE
//ReturnValue: NONE
/*************************************************************/
void LVD_Int_Disable(void)
{
	SYSCON->IMDR  |= LVD_INT_ST;
}
/*************************************************************/
//WDT INT ENABLE.
//EntryParameter:NONE
//ReturnValue: NONE
/*************************************************************/
void IWDT_Int_Enable(void)
{
	SYSCON->ICR = IWDT_INT_ST;				//clear LVD INT status
	SYSCON->IMER  |= IWDT_INT_ST;
}
/*************************************************************/
//WDT INT DISABLE.
//EntryParameter:NONE
//ReturnValue: NONE
/*************************************************************/
void IWDT_Int_Disable(void)
{
	SYSCON->IMDR  |= IWDT_INT_ST;
}
/*************************************************************/
//Reset status.
//EntryParameter:NONE
//ReturnValue: rsr_dat
//rsr_dat=0x01 power on reset
//rsr_dat=0x02 low voltage reset
//rsr_dat=0x04 ex-pin reset
//rsr_dat=0x10 wdt reset
//rsr_dat=0x40 ex clock invalid reset
//rsr_dat=0x80 cpu request reset
//rsr_dat=0x100 software reset
/*************************************************************/
U32_T Read_Reset_Status(void)
{
	return (SYSCON->RSR & 0x1ff);
}
/*************************************************************/
//external trigger  Mode Selection Functions
//EntryParameter:NewState,EXIPIN,EXI_tringer_mode
//NewState:ENABLE,DISABLE
//EXIPIN:EXI_PIN0/1/2/3/4/5/6/7/8/9/10/11/12/13/14/15/16/17/18/19
//EXI_tringer_mode:_EXIRT,_EXIFT
//ReturnValue: LVD detection flag
/*************************************************************/
void EXTI_trigger_CMD(FunctionalStatus NewState , SYSCON_EXIPIN_TypeDef  EXIPIN , EXI_tringer_mode_TypeDef EXI_tringer_mode)
{
	switch(EXI_tringer_mode)
	{
		case _EXIRT:
		if(NewState != DISABLE)
		{
			SYSCON->EXIRT |=EXIPIN;
		}
		else
		{
			SYSCON->EXIRT &=~EXIPIN;	
		}
		break;
		case _EXIFT:
		if(NewState != DISABLE)
		{
			SYSCON->EXIFT |=EXIPIN;
		}
		else
		{
			SYSCON->EXIFT &=~EXIPIN;	
		}
		break;
	}	
}
/*************************************************************/
//external interrupt enable and disable 
//EntryParameter:NewState,EXIPIN,* GPIOX
//* GPIOX:GPIOA,GPIOB
//EXIPIN:EXI_PIN0/1/2/3/4/5/6/7/8/9/10/11/12/13/14/15/16/17/18/19
//NewState:ENABLE,DISABLE
//ReturnValue:NONE
/*************************************************************/
void EXTI_interrupt_CMD(FunctionalStatus NewState , SYSCON_EXIPIN_TypeDef  EXIPIN)
{
	SYSCON->EXICR = 0X3FFFF;									//Claer EXI INT status
	if(NewState != DISABLE)
	{
		SYSCON->EXIER|=EXIPIN;								//EXI4 interrupt enable
		while(!(SYSCON->EXIMR&EXIPIN));						//Check EXI is enabled or not
		SYSCON->EXICR |=EXIPIN;								// Clear EXI status bit
	}
	else
	{
		SYSCON->EXIDR|=EXIPIN;
	}
}
/*************************************************************/
//GPIO EXTI interrupt
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void GPIO_EXTI_interrupt(CSP_GPIO_T * GPIOX,U32_T GPIO_IECR_VALUE)
{
	//GPIOX->IECR&=~GPIO_IECR_VALUE;
	GPIOX->IECR|=GPIO_IECR_VALUE;
}
/*************************************************************/
//PLCK goto SLEEP mode
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void PCLK_goto_idle_mode(void)
{
	__DOZE();
}  
/*************************************************************/
//PLCK goto SLEEP mode
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/

void PCLK_goto_deepsleep_mode(void)
{
	SYSCON->WKCR=0X1F<<8;				//选择deepSleep模式 IWDT RTC LPT LVD TCH唤醒
	delay_nms(100);
	__STOP();
}  

void CK_CPU_EnAllNormalIrq(void)
{
	__ASM volatile("csrs mstatus, 8");
}

void CK_CPU_DisAllNormalIrq(void)
{
	__ASM volatile("csrc mstatus, 8");
}

/*************************************************************/
//EXI0 Interrupt enable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void EXI0_Int_Enable(void)
{
	csi_vic_enable_irq(EXI0_IRQ_NUM);   
}

/*************************************************************/
//EXI0 Interrupt disable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void EXI0_Int_Disable(void)
{
    csi_vic_disable_irq(EXI0_IRQ_NUM);   
}

/*************************************************************/
//EXI1 Interrupt enable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void EXI1_Int_Enable(void)
{
	csi_vic_enable_irq(EXI1_IRQ_NUM);   
}

/*************************************************************/
//EXI1 Interrupt disable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void EXI1_Int_Disable(void)
{
   csi_vic_disable_irq(EXI1_IRQ_NUM); 
}

/*************************************************************/
//EXI2 Interrupt enable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void EXI2_Int_Enable(void)
{
	csi_vic_enable_irq(EXI2_IRQ_NUM);
}

/*************************************************************/
//EXI2 Interrupt disable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void EXI2_Int_Disable(void)
{
    csi_vic_disable_irq(EXI2_IRQ_NUM);  
}

/*************************************************************/
//EXI3 Interrupt enable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void EXI3_Int_Enable(void)
{
	csi_vic_enable_irq(EXI3_IRQ_NUM);  
}

/*************************************************************/
//EXI3 Interrupt disable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void EXI3_Int_Disable(void)
{
    csi_vic_disable_irq(EXI3_IRQ_NUM);  
}

/*************************************************************/
//EXI4 Interrupt enable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void EXI4_Int_Enable(void)
{
	csi_vic_enable_irq(EXI4_IRQ_NUM);    
}

/*************************************************************/
//EXI4 Interrupt disable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void EXI4_Int_Disable(void)
{
    csi_vic_disable_irq(EXI4_IRQ_NUM);  
}
/*************************************************************/
//SYSCON Interrupt enable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void SYSCON_VectorInt_Enable(void)
{
    csi_vic_enable_irq(SYSCON_IRQ_NUM);     
}

/*************************************************************/
//SYSCON Interrupt disable
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/
void SYSCON_VectorInt_Disable(void)
{
	csi_vic_disable_irq(SYSCON_IRQ_NUM);        
}
/*************************************************************/
//set as CLO output 
//EntryParameter:
//ReturnValue:NONE
/*************************************************************/
void SYSCON_CLO_CONFIG(CLO_IO_TypeDef clo_io)
{
	if (clo_io==CLO_PA08)
	{
		GPIOA0->CONHR = (GPIOA0->CONHR&0XFFFFFFF0) | 0X00000007;
	}
	if (clo_io==CLO_PA09)
	{
		GPIOA0->CONHR = (GPIOA0->CONHR&0XFFFFFF0F) | 0X00000060;
	}
	if (clo_io==CLO_PA02)
	{
		GPIOA0->CONLR = (GPIOA0->CONLR&0XFFFFF0FF) | 0X00000700;
	}
}
/*************************************************************/
//set CLO clk and div
//EntryParameter:clomxr/clodivr
//ReturnValue:NONE
/*************************************************************/
void SYSCON_CLO_SRC_SET(SystemClk_CLOMX_TypeDef clomxr,SystemClk_CLODIV_TypeDef clodivr)
{
	SYSCON->OPT1=(SYSCON->OPT1 & 0XFFFF80FF)|(clomxr<<8)|(clodivr<<12);
}
/*************************************************************/
//Software_Reset
//EntryParameter:None
//ReturnValue:MCU reset
/*************************************************************/
void SYSCON_Software_Reset(void)
{
	SYSCON->IDCCR=IDCCR_KEY|SWRST;
}
/*************************************************************/
//CPU_Reset
//EntryParameter:None
//ReturnValue:MCU CPU reset Only
/*************************************************************/
void SYSCON_CPU_Reset(void)
{
	SYSCON->IDCCR=IDCCR_KEY|CPURST;
}
/*************************************************************/
//Debug io lock
//EntryParameter:None
//ReturnValue:
/*************************************************************/
void Debug_IO_lock(void)		//默认锁定
{
	SYSCON->DBGCR=0X5a;
}
void Debug_IO_release(void)
{
	SYSCON->DBGCR=0X00;
}
/*************************************************************/
//Interrupt Priority initial
//EntryParameter:
/*************************************************************/
//CTL值越大中断优先级越高
//external int暂时使用硬件矢量中断
void All_IntVector_initial(void)
{
	U8_T i;
	irq_vectors_init();
	CLIC->MINTTHRESH=0<<24;
	CLIC->CLICCFG =(0x4<<1)|0x01;					//高4位有效
	for (i = 0; i < 64; i++) 
	{
		CLIC->CLICINT[i].ATTR =(CLIC->CLICINT[i].ATTR&0xf9)|(0x0<<1);	// tigger mode: level
        CLIC->CLICINT[i].ATTR |= 1;  	// use vector interrupt
		csi_vic_set_prio(i,0x01);
    }
	asm ("nop");
}

void Set_INT_Priority(U8_T int_name,U8_T int_level)
{
	csi_vic_set_prio(int_name,int_level);
}
/*************************************************************/
//IO REMAP
//EntryParameter:
//ReturnValue:NONE
/*************************************************************/
void GPIO_Remap(IOMAP_TypeDef IOMAP_NUM,IOMAP_DIR_TypeDef iomap_data)
{
	U8_T i;
	if(iomap_data&0x10)
	{
		iomap_data=iomap_data&0X0F;
		if(iomap_data==0)
		{
			for(i=0;i<28;i+=4)
			{
				if((SYSCON->IOMAP1&(0xf<<i))==0)
				{
					SYSCON->IOMAP1=SYSCON->IOMAP1|(0xf<<i);
				}
			}
		}
		if(IOMAP_NUM==10){SYSCON->IOMAP1=(SYSCON->IOMAP1&0xfffffff0)|iomap_data;GPIOB0->CONLR =(GPIOB0->CONLR&0XFFFFF0FF) | 0x00000A00;}			//G2.0	PB02_G20
		if(IOMAP_NUM==11){SYSCON->IOMAP1=(SYSCON->IOMAP1&0xffffff0f)|(iomap_data<<4);GPIOB0->CONLR =(GPIOB0->CONLR&0XFFFF0FFF) | 0x0000A000;}		//G2.1	PB03_G21
		if(IOMAP_NUM==12){SYSCON->IOMAP1=(SYSCON->IOMAP1&0xfffff0ff)|(iomap_data<<8);GPIOA0->CONHR =(GPIOA0->CONHR&0XFFFFFFF0) | 0x0000000A;}		//G2.2	PA08_G22
		if(IOMAP_NUM==13){SYSCON->IOMAP1=(SYSCON->IOMAP1&0xffff0fff)|(iomap_data<<12);GPIOA0->CONHR =(GPIOA0->CONHR&0XFFFFFF0F) | 0x000000A0;}		//G2.3	PA09_G23
		if(IOMAP_NUM==14){SYSCON->IOMAP1=(SYSCON->IOMAP1&0xfff0ffff)|(iomap_data<<16);GPIOA0->CONHR =(GPIOA0->CONHR&0XFFFFF0FF) | 0x00000A00;}		//G2.4	PA010_G24
		if(IOMAP_NUM==15){SYSCON->IOMAP1=(SYSCON->IOMAP1&0xff0fffff)|(iomap_data<<20);GPIOA0->CONHR =(GPIOA0->CONHR&0XFFFF0FFF) | 0x0000A000;}		//G2.5	PA011_G25
		if(IOMAP_NUM==16){SYSCON->IOMAP1=(SYSCON->IOMAP1&0xf0ffffff)|(iomap_data<<24);GPIOA0->CONHR =(GPIOA0->CONHR&0XFFF0FFFF) | 0x000A0000;}		//G2.6	PA012_G26	
		if(IOMAP_NUM==17){SYSCON->IOMAP1=(SYSCON->IOMAP1&0x0fffffff)|(iomap_data<<28);GPIOA0->CONHR =(GPIOA0->CONHR&0XFF0FFFFF) | 0x00A00000;}		//G2.7	PA013_G27
	}
	else
	{
		if(iomap_data==0)
		{
			for(i=0;i<28;i+=4)
			{
			if((SYSCON->IOMAP0&(0xf<<i))==0)
				{
					SYSCON->IOMAP0=SYSCON->IOMAP0|(0xf<<i);
				}
			}
		}
		if(IOMAP_NUM==0){SYSCON->IOMAP0=(SYSCON->IOMAP0&0xfffffff0)|iomap_data;GPIOA0->CONLR =(GPIOA0->CONLR&0XFFFFFFF0) | 0x0000000A;}			//G1.0  PA00_G10
		if(IOMAP_NUM==1){SYSCON->IOMAP0=(SYSCON->IOMAP0&0xffffff0f)|(iomap_data<<4);GPIOA0->CONLR =(GPIOA0->CONLR&0XFFFFFF0F) | 0x000000A0;}	//G1.1  PA01_G11
		if(IOMAP_NUM==2){SYSCON->IOMAP0=(SYSCON->IOMAP0&0xfffff0ff)|(iomap_data<<8);GPIOA0->CONLR =(GPIOA0->CONLR&0XFFFFF0FF) | 0x00000A00;}	//G1.2  PA02_G12
		if(IOMAP_NUM==3){SYSCON->IOMAP0=(SYSCON->IOMAP0&0xffff0fff)|(iomap_data<<12);GPIOA0->CONLR =(GPIOA0->CONLR&0XFFFF0FFF) | 0x0000A000;}	//G1.3  PA03_G13
		if(IOMAP_NUM==4){SYSCON->IOMAP0=(SYSCON->IOMAP0&0xfff0ffff)|(iomap_data<<16);GPIOA0->CONLR =(GPIOA0->CONLR&0XFFF0FFFF) | 0x000A0000;}	//G1.4	PA04_G14
		if(IOMAP_NUM==5){SYSCON->IOMAP0=(SYSCON->IOMAP0&0xff0fffff)|(iomap_data<<20);GPIOA0->CONLR =(GPIOA0->CONLR&0XFF0FFFFF) | 0x00A00000;}	//G1.5	PA05_G15
		if(IOMAP_NUM==6){SYSCON->IOMAP0=(SYSCON->IOMAP0&0xf0ffffff)|(iomap_data<<24);GPIOA0->CONLR =(GPIOA0->CONLR&0XF0FFFFFF) | 0x0A000000;}	//G1.6	PA06_G16
		if(IOMAP_NUM==7){SYSCON->IOMAP0=(SYSCON->IOMAP0&0x0fffffff)|(iomap_data<<28);GPIOA0->CONLR =(GPIOA0->CONLR&0X0FFFFFFF) | 0xA0000000;}	//G1.7	PA07_G17
	}
}

/******************* (C) COPYRIGHT 2023 APT Chip *****END OF FILE****/