/*
  ******************************************************************************
  * @file    apt32f103_wwdt.c
  * @author  
  * @version V1.00
  * @date    2023/02/01
  ******************************************************************************
  *THIS SOFTWARE WHICH IS FOR ILLUSTRATIVE PURPOSES ONLY WHICH PROVIDES 
  *CUSTOMER WITH CODING INFORMATION REGARDING THEIR PRODUCTS.
  *APT CHIP SHALL NOT BE HELD RESPONSIBILITY ADN LIABILITY FOR ANY DIRECT, 
  *INDIRECT DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF 
  *SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION 
  *CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.AND APT CHIP RESERVES 
  *THE RIGHT TO MAKE CHANGES IN THE SOFTWARE WITHOUT NOTIFICATION
  ******************************************************************************
  */
  
  
  /* Includes ------------------------------------------------------------------*/
#include "apt32f103_wwdt.h"


/*************************************************************/
//WWDT RESET CLEAR ALL REGISTER
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/  
void WWDT_DeInit(void)
{
	WWDT->CR 	= 0x000000FF;
	WWDT->CFGR 	= 0x000000FF;
	WWDT->RISR 	= WWDT_RESET_VALUE;
	WWDT->MISR	= WWDT_RESET_VALUE;
	WWDT->IMCR 	= WWDT_RESET_VALUE;
	WWDT->ICR 	= WWDT_RESET_VALUE;
}
/*************************************************************/
//WWDT CONFIG
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/ 
void WWDT_CONFIG(WWDT_PSCDIV_TypeDef PSCDIVX,U8_T WND_DATA,WWDT_DBGEN_TypeDef DBGENX)
{
	WWDT->CFGR =WND_DATA;
	WWDT->CFGR |= PSCDIVX |DBGENX;
}
/*************************************************************/
//WWDT ENABLE/DISABLE
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/ 
void WWDT_CMD(FunctionalStatus NewState)
{
	if (NewState != DISABLE)
	{
		WWDT->CR  |= 0x01<<8;						
	}
	else
	{
		WWDT->CR  &= 0xfffffeff;					
	}
}
/*************************************************************/
//WWDT load data
//EntryParameter:NONE
//ReturnValue:NONE
/*************************************************************/ 
void WWDT_CNT_Load(U8_T cnt_data)
{
	WWDT->CR  |= cnt_data;						//SET
}
/*************************************************************/
//WWDT INT ENABLE/DISABLE
//EntryParameter:NONE
//ReturnValue: NONE
/*************************************************************/
void WWDT_Int_Config(FunctionalStatus NewState)
{
	if (NewState != DISABLE)
	{
		WWDT->ICR = WWDT_EVI;				
		WWDT->IMCR  |= WWDT_EVI;
		csi_vic_enable_irq(WWDT_IRQ_NUM);
	}
	else
	{
		WWDT->IMCR  &= ~WWDT_EVI;					//CLR
		csi_vic_disable_irq(WWDT_IRQ_NUM); 
	}
}

/******************* (C) COPYRIGHT 2023 APT Chip *****END OF FILE****/