/*
 * Copyright (C) 2017-2019 Alibaba Group Holding Limited
 */

 /******************************************************************************
 * @file     startup.S
 * @brief    startup file. Should use with
 *           GCC for CSKY Embedded Processors
 * @version  V1.0
 * @date     29. July 2019
 ******************************************************************************/
#define MSTATUS_PRV1 0x1880

.section .bss
.align 2
    .globl g_trap_sp
    .type  g_trap_sp, object
g_trap_sp:
    .long 0
    .size g_trap_sp, .-g_trap_sp
//.section .vectors_inram, "aw", @progbits			 
.section .vectors_inrom, "ax", @progbits	
//******************************************************************************/	
    

//.section .trap_inram, "aw", @progbits
.section .trap_inrom, "ax", @progbits
.align  6
    .globl  _vector_table
    .type   _vector_table, @function
_vector_table:
	.long	DummyHandler
	.long  	INST_FETCH_ERROR_HANDLER 				//1 号取指令访问异常处理函数
	.long 	ILLEGAL_INST_ERROR_HANDLER 				//2 号非法指令异常处理函数
	.long   Debug_Breakpoint_ERROR_HANDLER 			//3 号调试断点异常
	.long	Load_INST_NoAligned_ACCESS_ERROR_HANDLER//4 号加载指令非对齐访问异常
	.long	load_INST_ACCESS_ERROR_HANDLER			//5 号加载指令访问错误异常
	.long	Save_INST_NoAligned_ACCESS_ERROR_HANDLER//6 号存储指令非对齐访问异常
	.long	Save_INST_ACCESS_ERROR_HANDLER			//7 号存储指令访问错误异常
	.long	UserMode_ECALL_ERROR_HANDLER//8 号用户模式环境调用异常
	.long 	DummyHandler		//未实现 9
	.long 	DummyHandler		//保留 10
	.long 	MACHINE_ECALL_HANDLER //11 号机器模式环境调用异常处理函数
	.long 	DummyHandler
	.long 	DummyHandler
	.long 	DummyHandler
	.long 	DummyHandler					//15				
	//******************
	/* CLINT interrupts */
    .long   DummyHandler		//0
    .long   DummyHandler		 
    .long   DummyHandler		 
    .long   Default_IRQHandler       // Software int of Machine mode---03 
    .long   DummyHandler      
    .long   DummyHandler      
    .long   DummyHandler      
    .long   Default_IRQHandler		//time		
    .long   DummyHandler		 
    .long   DummyHandler		 
    .long   DummyHandler		 
    .long   DummyHandler		 
    .long   DummyHandler
    .long   DummyHandler
    .long   DummyHandler
    .long   DummyHandler

    /* External interrupts */
    .long   DummyHandler			//16
    .long   Default_IRQHandler		//17 SYS
    .long   Default_IRQHandler			//18 IFC
    .long   Default_IRQHandler			//19 ADC
    .long   Default_IRQHandler			//20 EPT
    .long   Default_IRQHandler			//21 DMA
    .long   Default_IRQHandler			//22 WWDT
    .long   Default_IRQHandler			//23 EXT0
    .long   Default_IRQHandler			//24 EXT1
    .long   Default_IRQHandler			//25 GPTA0
    .long   DummyHandler			//26
    .long   DummyHandler			//27
    .long   Default_IRQHandler			//28 RTC
    .long   Default_IRQHandler			//29 UART0
    .long   Default_IRQHandler			//30 UART1
    .long   Default_IRQHandler			//31 UART2
    .long   Default_IRQHandler		//32 USART0
    .long   Default_IRQHandler			//33 I2C
    .long   DummyHandler			//34 
    .long   Default_IRQHandler			//35 SPI
    .long   Default_IRQHandler			//36 SIO
    .long   Default_IRQHandler		//37 EXI2to3
    .long   Default_IRQHandler		//38 EXI4to9
    .long   Default_IRQHandler		//39 EXI10to15
    .long   Default_IRQHandler			//40 CNTA
    .long   Default_IRQHandler			//41 TKEY
    .long   Default_IRQHandler			//42 LPT
    .long   DummyHandler			//43
    .long   Default_IRQHandler			//44 BT0
    .long   Default_IRQHandler			//45 BT1
    .long   Default_IRQHandler			//46 BT2
    .long   Default_IRQHandler			//47 BT3
	.long   DummyHandler			//48	 
    .long   DummyHandler			//49
    .long   DummyHandler			//50
    .long   DummyHandler			//51
    .long   DummyHandler			//52
    .long   DummyHandler			//53
    .long   DummyHandler			//54
    .long   DummyHandler			//55
    .long   DummyHandler			//56
    .long   DummyHandler			//57
    .long   DummyHandler			//58
    .long   DummyHandler			//59
    .long   DummyHandler			//60
    .long   DummyHandler			//61
    .long   DummyHandler			//62
    .long   DummyHandler			//63

	.size   _vector_table, . - _vector_table
/******************************************************************************
 * Functions:
 *     Default_IRQHandler(void);
 * ALL IRQ handler, Lookup table processing interrupt 
 ******************************************************************************/	
    .align  2
    .global Default_IRQHandler
    .weak   Default_IRQHandler
    .type   Default_IRQHandler, %function
Default_IRQHandler:
//	ipush
	
//.F_RegNotSave:
//
//    csrr    t1, mcause
    addi    sp, sp, -48
    sw      t0, 4(sp)
    sw      t1, 8(sp)
    csrr    t0, mepc
    csrr    t1, mcause
    sw      t1, 40(sp)
    sw      t0, 44(sp)
    csrs    mstatus, 8  // mstatus <-- mstatus | 8   bit3 =  MIE / global int EN

    sw      ra, 0(sp)
    sw      t2, 12(sp)
    sw      a0, 16(sp)
    sw      a1, 20(sp)
    sw      a2, 24(sp)
    sw      a3, 28(sp)
    sw      a4, 32(sp)
    sw      a5, 36(sp)
	
    andi    t1, t1, 0x3FF  //Get int ID
    slli    t1, t1, 2     // t1 <-- ID*4
    la      t0, g_irqvector
    add     t0, t0, t1
    lw      t2, (t0)
    jalr    t2
	
//	li      t0, MSTATUS_PRV1
//    csrs    mstatus, t0
//    
//.F_RegNotLoad:
//    ipop

    csrc    mstatus, 8   // Clear MIE bit of mstatus

    lw      a1, 40(sp)
    andi    a0, a1, 0x3FF

    /* clear pending */
    li      a2, 0xE000E100
    add     a2, a2, a0   //  a2 = ID+ 0xE000E100
    lb      a3, 0(a2)   //a3 = first byte of a2 when msb of the byte is 0, = 0xffffffxx,when msb of xx is 1
    li      a4, 1
    not     a4, a4      //a4 = 0xfffffffe
    and     a5, a4, a3  
    sb      a5, 0(a2)

    li      t0, MSTATUS_PRV1
    csrs    mstatus, t0
    csrw    mcause, a1
    lw      t0, 44(sp)
    csrw    mepc, t0
    lw      ra, 0(sp)
    lw      t0, 4(sp)
    lw      t1, 8(sp)
    lw      t2, 12(sp)
    lw      a0, 16(sp)
    lw      a1, 20(sp)
    lw      a2, 24(sp)
    lw      a3, 28(sp)
    lw      a4, 32(sp)
    lw      a5, 36(sp)

    addi    sp, sp, 48
    mret

.align  2
    .global trap
    .type   trap, %function
trap:
    /* Check for interrupt */
    addi    sp, sp, -4
    sw      t0, 0x0(sp)
    csrr    t0, mcause

    blt     t0, x0, .Lirq   //t0<0 , jump .Lirq  interupt --- 31bit =1 
							//t0>=0  next step  traps
    addi    sp, sp, 4    

    la      t0, g_trap_sp
    addi    t0, t0, -68
    sw      x1, 0(t0)
    sw      x2, 4(t0)
    sw      x3, 8(t0)
    sw      x4, 12(t0)
    sw      x6, 20(t0)
    sw      x7, 24(t0)
    sw      x8, 28(t0)
    sw      x9, 32(t0)
    sw      x10, 36(t0)
    sw      x11, 40(t0)
    sw      x12, 44(t0)
    sw      x13, 48(t0)
    sw      x14, 52(t0)
    sw      x15, 56(t0)
    csrr    a0, mepc
    sw      a0, 60(t0)
    csrr    a0, mstatus
    sw      a0, 64(t0)

    mv      a0, t0
    lw      t0, -4(sp)
    mv      sp, a0
    sw      t0, 16(sp)

	csrr 	t1, mcause
	la	 	t0,0xfff
	and 	t1,t1,t0
	slli 	t1, t1, 0x2			//向量号*4
	la 		t2, _vector_table
	add 	t1, t1, t2
	lw 		t2, 0(t1)
	jalr 	t2

.Lirq:
    lw      t0, 0x0(sp)
    addi    sp, sp, 4
    j       Default_IRQHandler

.align  6
    .weak   Default_Handler
    .global Default_Handler
    .type   Default_Handler, %function
Default_Handler:
    /* Check for nmi */
    addi    sp, sp, -8
    sw      t0, 0x0(sp)
    sw      t1, 0x4(sp)       
    csrr    t0, mcause
	li		t1,0x800003FF
    and     t0, t0, t1
    li      t1, 24
    beq     t0, t1, .NMI_Handler    //mcause&0x3ff == 24? .NMI_Handler: next step
    lw      t0, 0x0(sp)
    lw      t1, 0x4(sp)
    addi    sp, sp, 8
    j      trap

.NMI_Handler:
    lw      t0, 0x0(sp)
    lw      t1, 0x4(sp)
    addi    sp, sp, 8

    addi    sp, sp, -40
    sw      ra, 0(sp)
    sw      t0, 4(sp)
    sw      t1, 8(sp)
    sw      t2, 12(sp)
    sw      a0, 16(sp)    
    sw      a1, 20(sp)    
    sw      a2, 24(sp)
    sw      a3, 28(sp)
    sw      a4, 32(sp)
    sw      a5, 36(sp)

    la      t0, DummyHandler//g_nmivector
    lw      t0, (t0)
    jalr    t0

    lw      ra, 0(sp)
    lw      t0, 4(sp)
    lw      t1, 8(sp)
    lw      t2, 12(sp)
    lw      a0, 16(sp)
    lw      a1, 20(sp)
    lw      a2, 24(sp)
    lw      a3, 28(sp)
    lw      a4, 32(sp)
    lw      a5, 36(sp)
    addi    sp, sp, 40
    mret


    .size   Default_Handler, . - Default_Handler

    .text
    .align  2
_start:
    .text
    .align  2
    .globl  Reset_Handler
    .type   Reset_Handler, %function
Reset_Handler:
.option push
.option norelax							// do not replace  any branches or calls
    //la      gp, __global_pointer$
.option pop

    la      a0, Default_Handler	
	ori     a0, a0, 3
    csrw    mtvec, a0

    la      a0, _vector_table				//Interrupt vector base address 
	addi 	a0, a0, 64
    csrw    mtvt, a0
//initialize kernel stack
    la      sp, __stack_start
    csrw    mscratch, sp
	la		a4,__stack_start
	
	la  a5, 0x0
	sw a5, (a4)
    // Load data section 
    la      a0, _end_rodata
    la      a1, _start_data
    la      a2, _end_data
    bgeu    a1, a2, rodata_intial_2					//a1 >= a2, jmp -> 2
rodata_intial_1:
    lw      t0, (a0)					//data of a0 memory -> t0
    sw      t0, (a1)					//data 0f t0 -> memory 0f a1
    addi    a0, a0, 4
    addi    a1, a1, 4
    bltu    a1, a2, rodata_intial_1					//a1 <= a2, jmp -> 1
rodata_intial_2:

    /* Clear bss section */
    la      a0, _bss_start
    la      a1, _ebss
    bgeu    a0, a1, bss_intial_2
bss_intial_1:
    sw      zero, (a0)
    addi    a0, a0, 4
    bltu    a0, a1, bss_intial_1
bss_intial_2:

    jal     main

    .size   Reset_Handler, . - Reset_Handler	

DummyHandler:
  csrr t1, mexstatus  				//sys reset
  li   t0, 0x02
  li   t2, 0xfffffffc
  and  t1,t1,t2
  or   t1,t1,t0
  csrw mexstatus,t1
  jal _start
  .size   DummyHandler, . - DummyHandler	



	
