/*
  ******************************************************************************
  * @file    apt32f103_dma.h
  * @author 
  * @version V1.00
  * @date    2023/02/01
  ******************************************************************************
  *THIS SOFTWARE WHICH IS FOR ILLUSTRATIVE PURPOSES ONLY WHICH PROVIDES 
  *CUSTOMER WITH CODING INFORMATION REGARDING THEIR PRODUCTS.
  *APT CHIP SHALL NOT BE HELD RESPONSIBILITY ADN LIABILITY FOR ANY DIRECT, 
  *INDIRECT DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT OF 
  *SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION 
  *CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.AND APT CHIP RESERVES 
  *THE RIGHT TO MAKE CHANGES IN THE SOFTWARE WITHOUT NOTIFICATION
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef _apt32f103_dma_H
#define _apt32f103_dma_H

/* Includes ------------------------------------------------------------------*/
#include "apt32f103.h"

/**
  * @brief  DMA INT  Set
  */
typedef enum
{
	DMA_TCIT     	=	(0x01 << 30),  
	DMA_LTCIT    	=	(0x01 << 29)
}DMA_INT_TypeDef;  

typedef enum
{
	DMA_Triggle_SWTRIG = 0,
	DMA_Triggle_HWTRIG = 1
}DMA_Triggle_mode_TypeDef;

#define DMA5_TCIT		(0X01<<21)
#define DMA4_TCIT		(0X01<<20)
#define DMA3_TCIT		(0X01<<19)
#define DMA2_TCIT		(0X01<<18)
#define DMA1_TCIT		(0X01<<17)
#define DMA0_TCIT		(0X01<<16)
#define DMA5_LTCIT		(0X01<<5)
#define DMA4_LTCIT		(0X01<<4)
#define DMA3_LTCIT		(0X01<<3)
#define DMA2_LTCIT		(0X01<<2)
#define DMA1_LTCIT		(0X01<<1)
#define DMA0_LTCIT		(0X01<<0)

typedef enum
{
	DMA_HINC_EN		=	(0X00<<1),
	DMA_HINC_DIS	=	(0X01<<1)
}DMA_HINC_Cmd_TypeDef;

typedef enum
{
	DMA_LINC_EN		=	(0X00),
	DMA_LINC_DIS	=	0X01
}DMA_LINC_Cmd_TypeDef;

typedef enum
{
	DMA_Send_DSize_Byte 			=	(0x0<<24),		//8
	DMA_Send_DSize_Half_Word 	=	(0x1<<24),		//16
	DMA_Send_DSize_Word 			=	(0x2<<24)		//32
}DMA_Send_DSize_TypeDef;

typedef enum
{
	DMA_Send_TSize_1DSIZE 			=	(0x0<<28),		//每次传DSIZE*1
	DMA_Send_TSize_4DSIZE 			=	(0x1<<28)		//每次传DSIZE*4
}DMA_Send_TSize_TypeDef;

typedef enum
{
	DMA_Reload_EN		=	(0X0<<26),
	DMA_Reload_DIS		=	(0X1<<26)
}DMA_Reload_TypeDef;

typedef enum
{
	DMA_SendMode_Once	 	=	(0X0<<27),
	DMA_SendMode_Contine	=	(0X1<<27)
}DMA_SendMode_TypeDef;


extern void DMA_RESET(void);
extern void DMA_Channel_CMD(U8_T DMA_CESR);
extern void DMA_ConfigInterrupt_CMD(CSP_DMA_T *DMAX , FunctionalStatus NewState , DMA_INT_TypeDef DMA_INT_X);
extern void DMA_Trig_Mode(CSP_DMA_T *DMAX , DMA_Triggle_mode_TypeDef DMA_Triggle_mode);
extern void DMA_SWTRIG_Start(CSP_DMA_T *DMAX );
extern void DMA_HWTRIG_Start(CSP_DMA_T *DMAX );
extern void DMA_Stop(CSP_DMA_T *DMAX );
extern void DMA_CR_Config(CSP_DMA_T *DMAX , U16_T DAM_LTC , U16_T DAM_HTC , DMA_Send_TSize_TypeDef DMA_Send_TSize , DMA_Send_DSize_TypeDef DMA_Send_DSize ,
					DMA_Reload_TypeDef DMA_Reload_CMD , DMA_SendMode_TypeDef DMA_SendMode);
extern void DMA_Int_Enable(void);
extern void DMA_Int_Disable(void);
extern void DMA_Source_addr_set(CSP_DMA_T *DMAX ,  void *DAM_Source_addr , DMA_HINC_Cmd_TypeDef DMA_HINC_Cmd , DMA_LINC_Cmd_TypeDef DMA_LINC_Cmd);
extern void DMA_Dest_addr_set(CSP_DMA_T *DMAX ,  void *DAM_Dest_addr , DMA_HINC_Cmd_TypeDef DMA_HINC_Cmd , DMA_LINC_Cmd_TypeDef DMA_LINC_Cmd);

#endif   

/******************* (C) COPYRIGHT 2023 APT Chip *****END OF FILE****/